/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_CHANNEL_SELECTOR_H_INCLUDED_)
#define _HARKLIB_NODE_CHANNEL_SELECTOR_H_INCLUDED_ 1

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"

namespace hark
{
namespace node
{
    class ChannelSelector: public NodeDef
    {
    public:
        ChannelSelector();
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        template<typename T>
        data select_channels(size_t count, data inputData);

    private:
        std::vector<size_t> _selector;
        size_t _channel_count, _length;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_CHANNEL_SELECTOR_H_INCLUDED_) */

/* end of file */
